#! /bin/bash

# sitemap.sh v1.0
# Policy: GNU GPL
# (c) 1997/98 by Adam Kopacz / kLoGraFX
# Adam.K@klografx.de - http://www.kLoGraFX.de/


### USER SETTINGS #####################################

OUTFILE="sitemap.html"
TITLE="Map for Packet Storm Security"
COPYRIGHT="&copy; 1998 by Adam Kopacz / kLoGraFX"

TEXTCOLOR="#000000"
BGCOLOR="#C0C0C0"
XCOLOR="#DDDDDD"
TOPCOLOR="#FFDDDD"

#######################################################





NR=1
Z=1

echo -ne "\nCreating: $TITLE\n\n"

rm -f $OUTFILE

cat <<EOF >$OUTFILE
<html>
<head>
    <title>$TITLE</title>
</head>
<body text="$TEXTCOLOR" bgcolor="$BGCOLOR">

<font color="#993030"><center><hr><b>$TITLE</b><hr></font><br>

<table border="1" align="center" cellspacing="2" cellpadding="2">
<tr>
    <td bgcolor="$TOPCOLOR"><font size="-1"><b>Nr.</b></font></td>
    <td bgcolor="$TOPCOLOR"><font size="-1"><b>Link</b></font></td>
    <td align="right" bgcolor="$TOPCOLOR"><font size="-1"><b>Size (in bytes)</b></font></td>
    <td align="center" bgcolor="$TOPCOLOR"><font size="-1"><b>Last Modified</b></font></td>
    <td bgcolor="$TOPCOLOR"><font size="-1"><b>Title</b></font></td>
</tr>

EOF


for URL in `find -name \*.*htm* -print`
 do
  X=`echo "$URL" | cut -c 3-999`
  Y=`cat "$URL" | grep "<title>" -i | sed 's/<\/[Tt][Ii][Tt][Ll][Ee]>//' | sed 's/^.*>//'`
  
  if test "$Y" = ""
  then
    Y="- no title -"
  fi         
  
  echo -ne "$NR\t- $Y\n"

  if test "$Z" = "0"
  then
	echo -n "<tr><td align="right" bgcolor="$XCOLOR"><font size=-1>$NR</font></td>" >>$OUTFILE
	echo -n "<td bgcolor="$XCOLOR">" >>$OUTFILE
	echo -n '<font size="-1"><a href="' >>$OUTFILE
	echo -n "$X" >>$OUTFILE
	echo -n '">' >>$OUTFILE
	echo -n "$X</a></font></td><td align=right bgcolor=$XCOLOR><font size=-1>" >>$OUTFILE
	echo -n `/bin/ls -l $X` | cut -d\  -f5 >>$OUTFILE
	echo -n '</font></td>' >>$OUTFILE
	echo -n "<td align=center bgcolor=$XCOLOR>" >>$OUTFILE
	echo -n `find $URL -printf '%Td.%Tm.%TY'` >>$OUTFILE
	echo "</td><td bgcolor=$XCOLOR><font size=-1>$Y</font></td>" >>$OUTFILE 
  else
	echo -n "<tr><td align="right"><font size=-1>$NR</font></td>" >>$OUTFILE
	echo -n '<td><font size="-1"><a href="' >>$OUTFILE
	echo -n "$X" >>$OUTFILE
	echo -n '">' >>$OUTFILE
	echo -n "$X</a></font></td><td align=right><font size=-1>" >>$OUTFILE
	echo -n `/bin/ls -l $X` | cut -d\  -f5 >>$OUTFILE
	echo -n '</font></td><td align="center">' >>$OUTFILE
	echo -n `find $URL -printf '%Td.%Tm.%TY'` >>$OUTFILE
	echo "</td><td><font size=-1>$Y</font></td>" >>$OUTFILE 
  fi         

  if test "$Z" = "0"
  then
   Z=1
  else
   Z=0
  fi

  echo -ne '</tr>' >>$OUTFILE
  NR=$[ $NR + 1 ]
done

echo -ne '</table>' >>$OUTFILE


echo -e '<br>&nbsp;<br><font color="#403030"><hr>Created with <b><a href="http://www.kLoGraFX.de/" target="_top">sitemap.sh</a> v1.0</b> / ' >>$OUTFILE
echo -n `date` >>$OUTFILE
echo -n ' / ' >>$OUTFILE
echo -n `uname -n` >>$OUTFILE
echo -n ": " >>$OUTFILE
echo -n `uname -srm` >>$OUTFILE
echo -n "<br><font size=-1>$COPYRIGHT</font>" >>$OUTFILE
echo -e '<hr></font></center></html>\n</body>' >>$OUTFILE

echo -ne "\nDone, OUTFILE was: $OUTFILE\n\n"
echo
